Emissions

SUMO includes some small-sized tools and tests that help to develop and evaluate the implemented emission models. These tools are presented in the following.

# emissionsMap

This tool generates matrices of emissions for a given range of velocities, accelerations, and slopes, given the vehicle's emission class mainly.

The tool obtains parameter that describe the ranges and the emission classes to generate. If the option --iterate <BOOL> is set, emissionsMap iterates over all available emission classes. In this case, the option --output-file <PATH> should denote a folder the emission maps shall be written into. If --iterate <BOOL> is not set, --output-file <FILE> should name the file to generate and the emission class to write the map for must be defined using the option --emission-class <STRING>. If PHEMlight shall be used, one has to define the path to the CEP-files using the option --phemlight-path <PATH>.

The tool is located in <SUMO_HOME>/bin.

The image shows the visualization of CO2 emission of the HBEFA v2.1-based "P_7_6" emission class.

## Options

### Processing

Option | Description
--- | ---
-i <BOOL> --iterate <BOOL> | If set, maps for all available emissions are written
-e <STRING> --emission-class <STRING> | Defines the name of the emission class to generate the map for
--v-min <FLOAT> | Defines the minimum velocity boundary of the map to generate (in [m/s]); default: 0**
--v-max <FLOAT> | Defines the maximum velocity boundary of the map to generate (in [m/s]); default: 50**
--v-step <FLOAT> | Defines the velocity step size (in [m/s]); default: 2**
--a-min <FLOAT> | Defines the minimum acceleration boundary of the map to generate (in [m/s^2]); default: -4**
--a-max <FLOAT> | Defines the maximum acceleration boundary of the map to generate (in [m/s^2]); default: 4**
--a-step <FLOAT> | Defines the acceleration step size (in [m/s^2]); default: .5**
--s-min <FLOAT> | Defines the minimum slope boundary of the map to generate (in [°]); default: -10**
--s-max <FLOAT> | Defines the maximum slope boundary of the map to generate (in [°]); default: 10**
--s-step <FLOAT> | Defines the slope step size (in [°]); default: 1**

### Output

Option | Description
--- | ---
-o <FILE> --output-file <FILE> | Defines the file (or the path if --iterate was set) to write the map(s) into

The format of the output is a CSV-like with ; as the column separator:

    <speed>;<acceleration>;<slope>;<Pollutant-Type>;<Polutant-Value-in-mg/s-or-ml/s>

### Emissions

Option | Description
--- | ---
-p <PATH> --phemlight-path <PATH> | Determines where to load PHEMlight definitions from.

### Report

Option | Description
--- | ---
-v <BOOL> --verbose <BOOL> | Switches to verbose output; default: false**
-? <BOOL> --help <BOOL> | Prints the help screen

# emissionsDrivingCycle

This tools computes emissions given a timeline of speeds/accelerations for a single vehicle. The driving cycle definition must be given using the option --timeline-file <FILE>. It must be a ';'-separated .csv-file with the following columns:

- time (in [s]); must start at zero and be increasing in steps of 1 s
- velocity (in [m/s] unless --kmh is set, see below)
- acceleration (in [m/s^2]); this column may be omitted or recalculated using the option --compute-a
- optional: slope (in [°]); if given, one has to enable it using the option --have-slope

The tool generates a ';'-separated .csv file which contains the following columns:

- time (in [s])
- velocity (in [m/s])
- acceleration (in [m/s^2])
- slope (in [°])
- CO emissions (in [mg/s])
- CO2 emissions (in [mg/s])
- HC emissions (in [mg/s])
- PMx emissions (in [mg/s])
- NOx emissions (in [mg/s])
- fuel consumption (in [ml/s])
- electricity consumption (in [Wh/s])

Additionally, the sums of the generated emissions / the consumed fuel are printed on the screen.

The tool is located in <SUMO_HOME>/bin.

## Options

### Input

Option | Description
--- | ---
-t <FILE> --timeline-file <FILE> | Defines the file to read the driving cycle from.
-n <FILE> --netstate-file <FILE> | Defines the file to read the trajectory from either in netstate or in Amitran format.
-e <STRING> --emission-class <STRING> | Defines for which emission class the emissions shall be generated.

### Processing

Option | Description
--- | ---
-a <BOOL> --compute-a <BOOL> | If set, the acceleration is computed instead of being read from the file.
-s <BOOL> --skip-first <BOOL> | If set, the first line of the read file is skipped.
--kmh <BOOL> | If set, the given speed is interpreted as being given in km/h.
--have-slope <BOOL> | If set, the fourth column is read and used as slope (in [°]).
--slope <FLOAT> | Sets a global slope (in [°]) that is used if the file does not contain slope information.

### Output

Option | Description
--- | ---
-o <FILE> --output-file <FILE> | Defines the file to write the emission cycle results into.

### Emissions

Option | Description
--- | ---
-p <PATH> --phemlight-path <PATH> | Determines where to load PHEMlight definitions from.

### Report

Option | Description
--- | ---
-q <BOOL> --quiet <BOOL> | When set, the tool does not report anything; default: false**
-? <BOOL> --help <BOOL> | Prints the help screen

This part of SUMO was developed, reworked, or extended within the project "COLOMBO", co-funded by the European Commission within the Seventh Framework Programme.

#### Search

Enter your search terms:

#### Keyboard Shortcuts

Key | Action
--- | ---
`?` | Open this help dialog
`s` | Search the Documentation
`e` | Edit current page on GitHub